package refit.application.rezk;

import refit.client.REFITClientLibrary;
import refit.util.REFITTime;

public class REZKTestClientIncrement extends REZKTestClient {
	private String path;
	private int lastCount = 0;

	public REZKTestClientIncrement(REFITClientLibrary service) {
		super(service);
		path = "/counter";
	}

	@Override
	protected void work() throws Exception {
		// Invoke operation
		long startTime = REFITTime.nanoTime.getAsLong();
		int count = client.increment(path);
		long endTime = REFITTime.nanoTime.getAsLong();
		service.getStatistics().event((long) ((endTime - startTime) / 1000f), service.getNodeID(), "i");

		if (count <= lastCount) throw new Exception("Node counts backwards");
		lastCount = count;
	}
}
