package refit.application.rezk.datatree;

public enum REZKSQLOperation {
	CREATE("INSERT INTO " + REZKSQLDataTree.TABLE_NAME
			+ " (path,parent,data,version,size,children,lastaccess) VALUES (?,?,?,?,?,?,?)"),
	DELETE("DELETE FROM " + REZKSQLDataTree.TABLE_NAME + " WHERE path = ?"),
	GET_CHILDREN("SELECT path FROM " + REZKSQLDataTree.TABLE_NAME + " WHERE parent = ?"),
	GET_DATA("SELECT data,version,size,children,lastaccess FROM " + REZKSQLDataTree.TABLE_NAME + " WHERE path = ?"),
	SET_DATA("UPDATE " + REZKSQLDataTree.TABLE_NAME + " SET data = ?,version = ?,size = ?,children = ?, lastaccess = ? WHERE path = ?"),
	GET_STAT("SELECT version,size,children,lastaccess FROM " + REZKSQLDataTree.TABLE_NAME + " WHERE path = ?"),
	SET_STAT("UPDATE " + REZKSQLDataTree.TABLE_NAME + " SET version = ?,size = ?,children = ?, lastaccess = ? WHERE path = ?"),
	CHECKPOINT("SELECT path,data,version,size,children,lastaccess FROM " + REZKSQLDataTree.TABLE_NAME),
	CHECKPOINT_FUZZY("SELECT path,data,version,size,children,lastaccess,_rowid_ FROM " + REZKSQLDataTree.TABLE_NAME + " WHERE _rowid_ > ? LIMIT 10000");

	public static final REZKSQLOperation[] values = values();

	public final String command;

	REZKSQLOperation(String command) {
		this.command = command;
	}

}
