package refit.communication;

import java.nio.ByteBuffer;


public class REFITUnmarshaller {

	public static final REFITUnmarshaller instance = new REFITUnmarshaller();


	public ByteBuffer unmarshalMessage(ByteBuffer buffer) {
		// Analyze size field in header
		if (buffer.remaining() < Integer.BYTES) return null;
		int messageSize = buffer.getInt(buffer.position());
		if (buffer.remaining() < messageSize) return null;

		// Copy message
		int oldLimit = buffer.limit();
		int processedMark = buffer.position() + messageSize;
		buffer.limit(processedMark);
		ByteBuffer message = buffer.slice();

		// Move to next message
		buffer.position(processedMark);
		buffer.limit(oldLimit);

		return message;
	}

}
