package refit.test;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class HashMicrobenchmark {

	public static void main(String[] args) {
		/*
		MD5: Iteration time increases in 64 byte steps
		Steps: 192, 256, 304/320, 384
 		*/
		MessageDigest digest;
		final String digestName = "SHA-256";
		try {
			digest = MessageDigest.getInstance(digestName);
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			return;
		}

		for (int round = 0; round < 2; round++) {
			boolean isWarmup = round < 1;
			for (int i = 0; i <= 128; i += 8) {
				byte[] data = new byte[i];
				final int ITERATIONS = isWarmup ? 10000 : 500000;
				long timeBefore = System.nanoTime();
				for (int j = 0; j < ITERATIONS; j++) {
					digest.update(data);
					digest.digest();
				}
				long timeAfter = System.nanoTime();
				long timeDiff = timeAfter - timeBefore;
				if (!isWarmup) {
					System.out.printf("%s with %d bytes took: %d ns\n", digestName,
							i, timeDiff / ITERATIONS);
				}
			}

		}
	}
}
