package refit.test;

public class SchedulingMicrobenchmark {
	public static void main(String[] args) {
		long duration = 60 * 1000;
		if (args.length >= 1) {
			duration = Integer.parseInt(args[0]) * 1000;
		}

		long startTime = System.currentTimeMillis();
		long timeTicks = startTime;
		long lastCurrentTime = -1;
		boolean isLineClean = true;
		long timeLost = 0;

		// drain cpu credits
		while (timeLost < 10000) {
			long currentTime = System.currentTimeMillis();
			if (lastCurrentTime >= 0) {
				long timeStep = currentTime - lastCurrentTime;
				if (timeStep > 1) {
					if (!isLineClean) {
						System.out.println();
					}
					System.out.println(timeStep);
					timeLost += timeStep;
					isLineClean = true;
				}
			}
			lastCurrentTime = currentTime;

			if (currentTime >= timeTicks + 1000) {
				timeTicks += 1000;
				System.out.print(".");
				isLineClean = false;
			}

			if (currentTime > startTime + duration) {
				break;
			}
		}

		System.out.println("\nPhase two");
		while (true) {
			long roundStart = System.currentTimeMillis();
			long roundDuration = 3;
			long roundPause = 18;
			long currentTime;

			do {
				currentTime = System.currentTimeMillis();
			} while (currentTime - roundStart < roundDuration);

			long delta = currentTime - roundStart - roundDuration;
			if (delta > 0) {
				if (!isLineClean) {
					System.out.println();
				}
				System.out.println(delta);
				isLineClean = true;
			}

			try {
				Thread.sleep(roundPause);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}

			if (currentTime >= timeTicks + 1000) {
				timeTicks += 1000;
				System.out.print(".");
				isLineClean = false;
			}

			if (currentTime > startTime + duration) {
				break;
			}
		}
	}
}
