package refit.test.ping;

import refit.message.REFITMessageType;
import refit.replica.REFITBaseReplica;
import refit.scheduler.REFITScheduler;
import refit.scheduler.REFITSchedulerTaskType;

public class REFITPingReplica extends REFITBaseReplica {
	private final REFITPingStage pingStage;

	public REFITPingReplica(short id, boolean isSingleThreaded) {
		super(id, isSingleThreaded, false);

		this.pingStage = new REFITPingStage(this);
		addToInbound(REFITMessageType.REQUEST, pingStage);
	}

	@Override
	public String toString() {
		return "RPING";
	}

	@Override
	protected void assignTasks(REFITScheduler[] schedulers) {
		// Assign tasks to schedulers
		schedulers[3 % schedulers.length].assignTasks(group, REFITSchedulerTaskType.REPLICA_NETWORK_ENDPOINT_WORKER);
		schedulers[0 % schedulers.length].assignTasks(group, REFITSchedulerTaskType.ORDER_STAGE);
	}

	public static void main(String[] args) {
		standaloneMain(args);
	}
}
